extends layout

block headContent
	+title('Block Stats')

block content
	h1.h3 Block Stats
	hr

	if (rpcApiUnsupportedError)
		div.alert.alert-danger(style="margin-bottom: 200px;")
			span Your node version doesn't support the 
				span.text-monospace #{rpcApiUnsupportedError.rpc}
				span  RPC. To use this tool you need to upgrade to 
				span.text-monospace v#{rpcApiUnsupportedError.version}
				span  or later.

	else

		div.card.shadow-sm.mb-3
			div.card-body
				h3.h6.mb-0 Block Range
				hr

				div.clearfix
					div.float-left.mr-4
						div(id="time-range-buttons")
							h3.h6 Latest N Blocks
							div.btn-group
								a.btn.btn-primary.block-count-btn(href="javascript:void(0)", data-blockCount="180") 180
									small.ml-2 (~6h)
								a.btn.btn-outline-primary.block-count-btn(href="javascript:void(0)", data-blockCount="360") 360
									small.ml-2 (~12h)
								a.btn.btn-outline-primary.block-count-btn(href="javascript:void(0)", data-blockCount="720") 720
									small.ml-2 (~1d)

					div.float-left.mr-4
						div(id="block-selections-buttons")
							h3.h6 Preconfigured

							div.dropdown
								button.btn.btn-outline-primary.dropdown-toggle(type="button", id="preconfigured-dropdown", data-toggle="dropdown", aria-haspopup="true", aria-expanded="false") Selections
								div.dropdown-menu(aria-labelledby="preconfigured-dropdown")
									a.dropdown-item(href="javascript:void(0)", data-blocks="0-199") First 200 Blocks
									a.dropdown-item(href="javascript:void(0)", data-blocks="0-1000") First 10000

					div.float-left
						div(id="time-range-buttons")
							h3.h6 Custom Range

							form.form-inline.mr-3(id="custom-range-form")
								div.input-group
									input.form-control(type="number", id="custom-range-start", min="0", max=currentBlockHeight, placeholder="min height", style="width: 125px;")
									input.form-control(type="number", id="custom-range-end", min="0", max=currentBlockHeight, placeholder="max height", style="width: 125px;")
									div.input-group-append
										button.btn.btn-primary(type="submit") Go

		div#progress-wrapper.mb-huge
			div.card.shadow-sm.mb-3
				div.card-body
					h4.h6 Loading blocks: 
						span(id="block-progress-text")
					div.progress.mt-2(id="progress-bar", style="height: 7px;")
						div.progress-bar(id="data-progress", role="progressbar", aria-valuenow="0", aria-valuemin="0" ,aria-valuemax="100")
	

	- var graphIds = ["fee-rates", "max-fee-rates", "total-fee", "min-fees", "max-fees", "inputs-outputs", "tx-sizes", "max-tx-sizes", "volumes", "sizes", "subsidy", "mediantime", "txs", "utxo_increase"];
	
	- var graphTitles = ["Fee Rates (avg, median, min)", "Maximum Fee Rate", "Total Fees", "Minimum Tx Fee", "Maximum Tx Fee", "Input / Output Count", "Tx Sizes (avg, median, min)", "Maximum Tx Size", "Output Volume", "Block Size", "Subsidy", "Timestamp", "Tx Count", "UTXO Δ"];

	div(id="main-content", style="display: none;")
		div.card.shadow-sm.mb-3
			div.card-body
				div.clearfix
					each graphId, graphIndex in graphIds
						div.float-left.mr-3.mb-1
							div.form-check
								input.form-check-input.graph-toggle-checkbox(type="checkbox", id=("checkbox-" + graphId) checked="checked", data-graphId=graphId, autocomplete="off")
								label.form-check-label(for=("checkbox-" + graphId)) #{graphTitles[graphIndex]}

					div.float-left.mr-3.mb-1
						a.mr-3(id="link-show-all", href="javascript:void(0)") show all
						a(id="link-hide-all", href="javascript:void(0)") hide all

		div.row.clearfix
			each graphId, graphIndex in graphIds
				div.col-lg-6.float-left
					div.card.shadow-sm.mb-3.graph-wrapper(id=`graph-wrapper-${graphId}`)
						div.card-body
							h3.h6.mb-0 #{graphTitles[graphIndex]}
							hr

							canvas.mb-3(id=graphId)


block endOfBody
	script(src="/js/chart.bundle.min.js", integrity="sha384-qgOtiGNaHh9fVWUnRjyHlV39rfbDcvPPkEzL1RHvsHKbuqUqM6uybNuVnghY2z4/")

	script(src='/js/decimal.min.js', integrity="sha384-zcNJYsoavmOdYj5MgXBBIO8scbka8MlR5mSGt0GKjdqbm26j4w0yVyOb9s5rY7Jh")

	script.
		var currentBlockHeight = !{currentBlockHeight};
		$(document).ready(function() {
			$("#time-range-buttons .block-count-btn").on("click", function() {
				// highlight current selection
				$("#time-range-buttons .block-count-btn").removeClass("btn-primary").addClass("btn-outline-primary");
				$(this).addClass("btn-primary").removeClass("btn-outline-primary");
				$("#preconfigured-dropdown").removeClass("btn-primary").addClass("btn-outline-primary");

				var blockCount = parseInt($(this).attr("data-blockCount"));

				$("#data-progress").css("width", "0%");
				$("#block-progress-text").text("");

				$("#main-content").hide();
				$("#progress-wrapper").show();
				getData(currentBlockHeight, blockCount, 15);
			});

			$("#block-selections-buttons .dropdown-item").on("click", function() {
				// highlight current selection
				$("#time-range-buttons .block-count-btn").removeClass("btn-primary").addClass("btn-outline-primary");
				$("#preconfigured-dropdown").removeClass("btn-outline-primary").addClass("btn-primary");

				var blocks = $(this).attr("data-blocks");
				var bStartEnd = blocks.split("-");
				var bStart = parseInt(bStartEnd[0]);
				var bEnd = parseInt(bStartEnd[1]);

				$("#data-progress").css("width", "0%");
				$("#block-progress-text").text("");

				$("#main-content").hide();
				$("#progress-wrapper").show();

				getData(bEnd, bEnd - bStart + 1, 15);
			});

			$("#custom-range-form").on("submit", function() {
				// highlight current selection
				$("#time-range-buttons .block-count-btn").removeClass("btn-primary").addClass("btn-outline-primary");
				$("#preconfigured-dropdown").removeClass("btn-primary").addClass("btn-outline-primary");

				var bStart = parseInt($("#custom-range-start").val());
				var bEnd = parseInt($("#custom-range-end").val());
				if ((bEnd - bStart) > 1008) {
					alert("Max allowed range has to be smaller than 1008 blocks");
					return false;
				}

				$("#data-progress").css("width", "0%");
				$("#block-progress-text").text("");

				$("#main-content").hide();
				$("#progress-wrapper").show();

				getData(bEnd, bEnd - bStart + 1, 15);

				return false;
			});

			$(".graph-toggle-checkbox").change(function() {
				var graphId = $(this).attr("data-graphId");

				$("#graph-wrapper-" + graphId).toggle();
			});

			$("#link-show-all").on("click", function() {
				$(".graph-toggle-checkbox").each(function() {
					$(this).prop("checked", true);
				});

				$(".graph-wrapper").each(function() {
					$(this).show();
				});
			});

			$("#link-hide-all").on("click", function() {
				$(".graph-toggle-checkbox").each(function() {
					$(this).prop("checked", false);
				});

				$(".graph-wrapper").each(function() {
					$(this).hide();
				});
			});
		});

		function getData(blockStart, count, chunkSize) {
			$("#time-range-buttons .block-count-btn").addClass("disabled");
			$("#block-selections-buttons .dropdown-item").addClass("disabled");

			var chunks = [];
			var blockIndex = blockStart;
			while (blockIndex > blockStart - count) {
				var chunk = [];
				for (var i = blockIndex; (i > (blockIndex - chunkSize) && i > (blockStart - count)); i--) {
					chunk.push(i);
				}

				blockIndex -= chunkSize;
				chunks.push(chunk);
			}

			console.log(JSON.stringify(chunks));

			var results = [];

			var statusCallback = function(chunkIndexDone, chunkCount) {

				var wPercent = `${parseInt(100 * (chunkIndexDone + 1) / parseFloat(chunkCount))}%`;

				$("#data-progress").css("width", wPercent);
				$("#block-progress-text").text(`${Math.min(((chunkIndexDone + 1) * chunkSize), count).toLocaleString()} of ${count.toLocaleString()} (${wPercent})`);
			};

			var finishedCallback = function() {
				$("#time-range-buttons .block-count-btn").removeClass("disabled");
				$("#block-selections-buttons .dropdown-item").removeClass("disabled");

				var summary = summarizeData(results);

				var red = "#dc3545";
				var green = "#28a745";
				var blue = "#007bff";

				createGraph("fee-rates", ["avg-fee-rate", "median-fee-rate", "min-fee-rate"], [summary.avgfeerate, summary.medianfeerate, summary.minfeerate], [blue, red, green], "!{coinConfig.baseCurrencyUnit.name}/B");
				
				createGraph("max-fee-rates", ["max-fee-rate"], [summary.maxfeerate], [blue], "!{coinConfig.baseCurrencyUnit.name}/B");

				createGraph("total-fee", ["total-fee"], [summary.totalfee], [blue], "!{coinConfig.defaultCurrencyUnit.name}");

				createGraph("min-fees", ["min-fee"], [summary.minfee], [blue], "!{coinConfig.baseCurrencyUnit.name}");
				createGraph("max-fees", ["max-fee"], [summary.maxfee], [blue], "!{coinConfig.baseCurrencyUnit.name}");

				createGraph("inputs-outputs", ["inputs", "outputs"], [summary.inputs, summary.outputs], [blue, green], "Count");

				createGraph("tx-sizes", ["avg-tx-size", "median-tx-size", "min-tx-size"], [summary.avgtxsize, summary.mediantxsize, summary.mintxsize], [blue, red, green], "Bytes");

				createGraph("max-tx-sizes", ["max-tx-size"], [summary.maxtxsize], [blue], "Bytes");

				createGraph("volumes", ["volume"], [summary.totaloutput], [blue], "!{coinConfig.defaultCurrencyUnit.name}");

				createGraph("sizes", ["size"], [summary.size], [blue], "Bytes");

				createGraph("subsidy", ["subsidy"], [summary.subsidy], [blue], "!{coinConfig.defaultCurrencyUnit.name}");

				createGraph("mediantime", ["mediantime"], [summary.mediantime], [blue], "Epoch Time");

				createGraph("txs", ["txs"], [summary.txs], [blue], "Count");

				createGraph("utxo_increase", ["utxo_increase"], [summary.utxo_increase], [blue], "Count");

				


				$("#main-content").show();
				$("#progress-wrapper").hide();
			};

			getBlockData(results, chunks, 0, statusCallback, finishedCallback);
		}

		function getBlockData(results, chunks, chunkIndex, statusCallback, finishedCallback) {
			if (chunkIndex > chunks.length - 1) {
				finishedCallback();

				return;
			}

			var url = `/api/block-stats-by-height/${chunks[chunkIndex]}`;

			$.ajax({
				url: url

			}).done(function(result) {
				for (var i = 0; i < result.length; i++) {
					results.push(result[i]);
				}

				statusCallback(chunkIndex, chunks.length);
				
				getBlockData(results, chunks, chunkIndex + 1, statusCallback, finishedCallback);
			});
		}

		var satsMultiplier = !{coinConfig.baseCurrencyUnit.multiplier};
		function summarizeData(results) {
			var summary = {};

			summary.avgfeerate = [];
			summary.medianfeerate = [];
			summary.minfeerate = [];

			summary.maxfeerate = [];

			summary.totalfee = [];

			summary.minfee = [];
			summary.maxfee = [];

			summary.inputs = [];
			summary.outputs = [];

			summary.avgtxsize = [];
			summary.mediantxsize = [];
			summary.mintxsize = [];

			summary.maxtxsize = [];
			
			summary.totaloutput = [];

			summary.size = [];

			summary.subsidy = [];

			summary.mediantime = [];

			summary.txs = [];

			summary.utxo_increase = [];

			for (var i = results.length - 1; i >= 0; i--) {
				summary.avgfeerate.push({x:results[i].height, y:results[i].avgfeerate * satsMultiplier});
				if (results[i].feerate_percentiles !== undefined) {
					summary.medianfeerate.push({x:results[i].height, y:results[i].feerate_percentiles[2] * satsMultiplier});
				} else {
					summary.medianfeerate.push({x:results[i].height, y:results[i].medianfeerate * satsMultiplier});
				}
				summary.minfeerate.push({x:results[i].height, y:results[i].minfeerate * satsMultiplier});
				
				summary.maxfeerate.push({x:results[i].height, y:results[i].maxfeerate * satsMultiplier});

				summary.totalfee.push({x:results[i].height, y:new Decimal(results[i].totalfee)});
				
				summary.minfee.push({x:results[i].height, y:results[i].minfee * satsMultiplier});
				summary.maxfee.push({x:results[i].height, y:results[i].maxfee * satsMultiplier});
				
				summary.inputs.push({x:results[i].height, y:results[i].ins});
				summary.outputs.push({x:results[i].height, y:results[i].outs});
				
				summary.avgtxsize.push({x:results[i].height, y:results[i].avgtxsize});
				summary.mediantxsize.push({x:results[i].height, y:results[i].mediantxsize});
				summary.mintxsize.push({x:results[i].height, y:results[i].mintxsize});

				summary.maxtxsize.push({x:results[i].height, y:results[i].maxtxsize});
				
				summary.totaloutput.push({x:results[i].height, y:new Decimal(results[i].total_out)});
				
				summary.size.push({x:results[i].height, y:results[i].total_size});
				
				summary.subsidy.push({x:results[i].height, y:results[i].subsidy});

				summary.mediantime.push({x:results[i].height, y:results[i].mediantime});

				summary.txs.push({x:results[i].height, y:results[i].txs});

				summary.utxo_increase.push({x:results[i].height, y:results[i].utxo_increase});
			}

			return summary;
		}

		var graphsById = {};
		function createGraph(chartid, names, datas, colors, yunit) {
			var datasets = [];

			for (var i = 0; i < names.length; i++) {
				datasets.push({
					label: names[i],
					data: datas[i],
					borderWidth: 2,
					borderColor: colors[i],
					backgroundColor: 'rgba(0, 0, 0, 0)',
					pointRadius: 1
				});
			}

			// update data in graph if we already created, otherwise create anew
			if (graphsById[chartid]) {
				graph = graphsById[chartid];
				graph.data = { datasets: datasets };
				graph.update();

			} else {
				var ctx = document.getElementById(chartid).getContext('2d');
				var graph = new Chart(ctx, {
					type: 'line',
					data: {
						datasets: datasets
					},
					options: {
						// disable all animations
						animation: { duration: 0 },
						hover: { animationDuration: 0 },
						responsiveAnimationDuration: 0,

						legend: {
							display: (datasets.length > 1)
						},
						scales: {
							xAxes: [{
								type: 'linear',
								position: 'bottom',
								scaleLabel: {
									display: true,
									labelString: 'Block'
								},
							}],
							yAxes: [{
								scaleLabel: {
									display: true,
									labelString: yunit
								}
							}]
						},
						tooltips: {
							mode: 'index',
							intersect: false
						}
					}
				});

				graphsById[chartid] = graph;
			}
		}

	if (rpcApiUnsupportedError == null)
		script.
			$(document).ready(function() {
				getData(currentBlockHeight, 180, 15);
			});
		
